org.apache.xpath.functions

## Class FunctionOneArg

- java.lang.Object
- - org.apache.xpath.Expression
  - - org.apache.xpath.functions.Function
    - - org.apache.xpath.functions.FunctionOneArg

All Implemented Interfaces:
  java.io.Serializable, SourceLocator, ExpressionNode, ExpressionOwner, XPathVisitable

Direct Known Subclasses:
  FuncBoolean, FuncCeiling, FuncCount, FuncExtElementAvailable, FuncExtFunctionAvailable, FuncFloor, FuncId, FuncLang, FuncNot, FuncRound, FuncSum, FuncSystemProperty, Function2Args, FunctionDef1Arg, FuncUnparsedEntityURI

    public class FunctionOneArg
    extends Function
    implements ExpressionOwner

Base class for functions that accept one argument.

See Also:
  Serialized Form
Usage:
  **For advanced use only**

### Constructor Summary

Constructors
Constructor and Description
`FunctionOneArg()`

### Method Summary

Methods
`void` `callArgVisitors(XPathVisitor visitor)` Call the visitors for the function arguments.
`boolean` `canTraverseOutsideSubtree()` Tell if this expression or it's subexpressions can traverse outside the current subtree.
`void` `checkNumberArgs(int argNum)` Check that the number of arguments passed to this function is correct.
`boolean` `deepEquals(Expression expr)` Compare this object with another object and see if they are equal, include the sub heararchy.
`void` `fixupVariables(java.util.Vector vars, int globalsSize)` This function is used to fixup variables from QNames to stack frame indexes at stylesheet build time.
`Expression` `getArg0()` Return the first argument passed to the function (at index 0).
`Expression` `getExpression()` Get the raw Expression object that this class wraps.
`void` `setArg(Expression arg, int argNum)` Set an argument expression for a function.
`void` `setExpression(Expression exp)` Set the raw expression object for this object.

### Methods inherited from class org.apache.xpath.functions.Function

`callVisitors, execute, postCompileStep`

### Methods inherited from class org.apache.xpath.Expression

`asIterator, asIteratorRaw, asNode, assertion, bool, error, execute, execute, execute, executeCharsToContentHandler, exprAddChild, exprGetChild, exprGetNumChildren, exprGetParent, exprSetParent, getColumnNumber, getExpressionOwner, getLineNumber, getPublicId, getSystemId, isNodesetExpr, isStableNumber, num, warn, xstr`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### FunctionOneArg

    public FunctionOneArg()

### Method Detail

#### getArg0

    public Expression getArg0()

Return the first argument passed to the function (at index 0).

Returns:
  An expression that represents the first argument passed to the function.

#### setArg

    public void setArg(Expression arg,
              int argNum)
                throws WrongNumberArgsException

Set an argument expression for a function. This method is called by the XPath compiler.

Overrides:
  `setArg` in class `Function`
Parameters:
  `arg` - non-null expression that represents the argument.
  `argNum` - The argument number index.
Throws:
  `WrongNumberArgsException` - If the argNum parameter is greater than 0.

#### checkNumberArgs

    public void checkNumberArgs(int argNum)
                         throws WrongNumberArgsException

Check that the number of arguments passed to this function is correct.

Overrides:
  `checkNumberArgs` in class `Function`
Parameters:
  `argNum` - The number of arguments that is being passed to the function.
Throws:
  `WrongNumberArgsException`

#### canTraverseOutsideSubtree

    public boolean canTraverseOutsideSubtree()

Tell if this expression or it's subexpressions can traverse outside the current subtree.

Overrides:
  `canTraverseOutsideSubtree` in class `Expression`
Returns:
  true if traversal outside the context node's subtree can occur.

#### fixupVariables

    public void fixupVariables(java.util.Vector vars,
                      int globalsSize)

This function is used to fixup variables from QNames to stack frame indexes at stylesheet build time.

Specified by:
  `fixupVariables` in class `Expression`
Parameters:
  `vars` - List of QNames that correspond to variables. This list should be searched backwards for the first qualified name that corresponds to the variable reference qname. The position of the QName in the vector from the start of the vector will be its position in the stack frame (but variables above the globalsTop value will need to be offset to the current stack frame).

#### callArgVisitors

    public void callArgVisitors(XPathVisitor visitor)

Description copied from class: `Function`
Call the visitors for the function arguments.

Overrides:
  `callArgVisitors` in class `Function`
See Also:
  `XPathVisitable.callVisitors(ExpressionOwner, XPathVisitor)`

#### getExpression

    public Expression getExpression()

Description copied from interface: `ExpressionOwner`
Get the raw Expression object that this class wraps.

Specified by:
  `getExpression` in interface `ExpressionOwner`
Returns:
  the raw Expression object, which should not normally be null.
See Also:
  `ExpressionOwner.getExpression()`

#### setExpression

    public void setExpression(Expression exp)

Description copied from interface: `ExpressionOwner`
Set the raw expression object for this object.

Specified by:
  `setExpression` in interface `ExpressionOwner`
Parameters:
  `exp` - the raw Expression object, which should not normally be null.
See Also:
  `ExpressionOwner.setExpression(Expression)`

#### deepEquals

    public boolean deepEquals(Expression expr)

Description copied from class: `Expression`
Compare this object with another object and see if they are equal, include the sub heararchy.

Overrides:
  `deepEquals` in class `Function`
Parameters:
  `expr` - Another expression object.
Returns:
  true if this objects class and the expr object's class are the same, and the data contained within both objects are considered equal.
See Also:
  `Expression.deepEquals(Expression)`